/*
 * This is a simple modification of the work by Christophe Devine located
 * at http://www.cr0.net:8040/code/crypto/des/, released GPL.
 * As such my modifications, should anyone anywhere for any reason
 * ever care, are also released GPL.
 *
 * T W Bennet
 */

#ifndef _CRIPDES_H
#define _CRIPDES_H

#ifndef uint8
#define uint8  unsigned char
#endif

#ifndef uint16
#define uint16  unsigned short
#endif

#ifndef uint32
#define uint32 unsigned long int
#endif

#ifndef uint64
#define uint64 unsigned long long
#endif

typedef struct
{
    uint32 esk[32];     /* DES encryption subkeys */
    uint32 dsk[32];     /* DES decryption subkeys */
}
des_context;

int  des_set_key( des_context *ctx, uint8 key[3] );
void des_encrypt( des_context *ctx, uint8 input[8], uint8 output[8] );
void des_decrypt( des_context *ctx, uint8 input[8], uint8 output[8] );

#endif /* cripdes.h */
